<script setup lang="ts">
const props = defineProps({
  pageObj: {
    type: Object,
    default: () => ({})
  },
  totalPage: {
    type: Number,
    default: () => 0
  }
})
const emit = defineEmits(['turn-page'])
const current = computed(() => {
  return props.pageObj.currentPage
})
const pages = computed(() => {
  let pages = [],
    i
  if (props.pageObj.currentPage < props.pageObj.pageSize) {
    i = Math.min(props.pageObj.pageSize, props.totalPage)
    while (i) {
      pages.unshift(i--)
    }
  } else {
    let middle =
        props.pageObj.currentPage - Math.floor(props.pageObj.pageSize / 2),
      i = props.pageObj.pageSize
    if (middle > props.totalPage - props.pageObj.pageSize) {
      middle = props.totalPage - props.pageObj.pageSize + 1
    }
    while (i--) {
      pages.push(middle++)
    }
  }
  return pages
})
const leftPage = computed(() => {
  let left

  if (props.pageObj.currentPage < props.pageObj.pageSize) {
    left = 1
  } else {
    left = props.pageObj.currentPage - Math.floor(props.pageObj.pageSize / 2)

    if (left > props.totalPage - props.pageObj.pageSize) {
      left = props.totalPage - props.pageObj.pageSize + 1
    }
  }
  return left
})
const rightPage = computed(() => {
  const addNumber = props.pageObj.pageSize - 1
  return leftPage.value + addNumber
})
const turnPage = (activePage: any) => {
  if (activePage < 1 || activePage > props.totalPage) return

  emit('turn-page', activePage)
}
</script>

<template>
  <nav v-show="totalPage > 1">
    <ul class="pagination">
      <li class="page-item chevrons-left chevron">
        <p class="page-link" @click="turnPage(1)">
          <img alt="chevrons-left" src="@/assets/icons/chevrons-left.svg" />
        </p>
      </li>
      <li class="page-item chevron-left chevron">
        <p class="page-link" @click="turnPage(current - 1)">
          <img alt="chevron-left" src="@/assets/icons/chevron-left.svg" />
        </p>
      </li>
      <li
        v-show="pageObj.currentPage !== 1 && pageObj.currentPage > 4"
        class="page-item page-number"
      >
        <a class="page-link" href="javascript:void(0)" @click="turnPage(1)"
          >1</a
        >
      </li>
      <li
        v-show="pageObj.currentPage !== 1 && leftPage > 1"
        class="page-item disabled"
      >
        <a class="page-link" href="javascript:void(0)">...</a>
      </li>
      <li
        v-for="index in pages"
        :key="index"
        :class="{ active: pageObj.currentPage === index }"
        class="page-item page-number"
        @click="turnPage(index)"
      >
        <a class="page-link" href="javascript:void(0)">{{ index }}</a>
      </li>
      <li
        v-show="
          totalPage !== pageObj.currentPage &&
          totalPage !== 0 &&
          rightPage < totalPage - 1
        "
        class="page-item disabled"
      >
        <a class="page-link" href="javascript:void(0)">...</a>
      </li>
      <li
        v-show="
          totalPage !== pageObj.currentPage &&
          totalPage !== 0 &&
          rightPage < totalPage
        "
        class="page-item page-number"
      >
        <a
          class="page-link"
          href="javascript:void(0)"
          @click="turnPage(totalPage)"
        >
          {{ totalPage }}
        </a>
      </li>
      <li class="page-item chevron-right chevron">
        <p class="page-link" @click="turnPage(current + 1)">
          <img alt="chevron-right" src="@/assets/icons/chevron-right.svg" />
        </p>
      </li>
      <li class="page-item chevrons-right chevron">
        <p class="page-link" @click="turnPage(totalPage)">
          <img alt="chevrons-right" src="@/assets/icons/chevrons-right.svg" />
        </p>
      </li>
    </ul>
  </nav>
</template>

<style lang="scss" scoped>
/** style */
.pagination {
  display: flex;
  justify-content: center;
  align-items: center;
  width: 509px;
  height: 24px;
  margin: 0px auto;
  user-select: none;
  > li {
    position: relative;
    width: 24px;
    height: 24px;
    &.page-number {
      margin: 0 4px;
      border-radius: 100%;
      overflow: hidden;
      border: 1px solid #cccccc;
    }
    > a {
      color: #666666;
      font-size: 14px;
      font-family: 'Roboto';
      font-style: normal;
      font-weight: 400;
      border: none;
      line-height: 24px;
      position: absolute;
      left: 0;
      top: 0;
      margin: 0;
      display: block;
      width: 24px;
      height: 24px;
      padding: 0;
      text-align: center;
    }
    > p {
      padding: 0;
      margin: 0;
      border: 0;
    }
    &.page-number.active {
      border: 1px solid #fd832c;
      .page-link {
        background: #fd832c;
      }
    }
    &.chevron-left {
      margin-right: 56px;
    }
    &.chevrons-left {
      margin-right: 20px;
    }
    &.chevron-right {
      // margin: 0 56px;
      margin-left: 56px;
    }
    &.chevrons-right {
      margin-left: 20px;
    }
    &.chevron:focus {
      outline: none;
    }
  }
}
</style>
